#include <stdio.h>
#include <stdlib.h>


typedef struct cell* ptarbre;
typedef struct cell* ptcellule;

typedef struct cell {
  char lettre;
  ptarbre arbre; // Descend d'un étage dans le mot (lettre suivante du mot)
  ptcellule suivant; // Lettre suivante stockée à l'étage arbre en (ieme position)
} cell;

/* Pas utile 
void init_dico()
{
  ptarbre arbre;
  arbre=NULL;
}
*/
ptarbre rech(ptarbre arbre, char lettre)
// recherche une lettre en ième position (correspondant à arbre)
// Retourne l'adresse de l'abre contenant la lettre à cette position
{
  while((arbre!=NULL) && (arbre->lettre != lettre))
    {
      printf("lettre : %c lettre cherchee : %c\n", (arbre->lettre),lettre);
      arbre=arbre->suivant;
    }
  return arbre;
}
void init_dico(ptarbre *parbre, char lettre)
{
  (*parbre)=malloc(sizeof(cell));
  (*parbre)->arbre=malloc(sizeof(cell));
  (*parbre)->suivant=NULL;
  (*parbre)->lettre=lettre;
  printf("init dico\n");
}

void ajout_dico(ptarbre *parbre, ptarbre *parbresuiv, char lettre)
{
  *parbresuiv=malloc(sizeof(cell));
  (*parbre)->suivant=*parbresuiv; // On relie la nouvelle lettre à l'avant dernière lettre
  (*parbresuiv)->arbre=malloc(sizeof(cell));
  (*parbresuiv)->suivant=NULL;
  (*parbresuiv)->lettre=lettre;
    printf("ajout lettre : %c \n",(*parbresuiv)->lettre);
}

void affiche_dico(ptarbre arbre)
// affiche tout le dictionnaire à partir de l'arbre (donc le numéro de lettre) sélectionné
{
  
}
  

int main()
{
  ptarbre arbre_originel,arbre;
  arbre_originel=NULL;
  char c,t;
  ptarbre rec;
  // Ouvrir fichier
  FILE *fp = fopen("words1.txt","r");
  if (fp==NULL)
    printf("words1 inaccessible \n",fp);
  else
    printf("words1 accessible \n",fp);

  while (fscanf(fp,"%c",&c)!= EOF) // lecture de tout le fichier
    {
      // while (fscanf(fp,"%d",&c)!='\n') // Tant que le mot n'est pas fini, on ajoute les lettres à la suite
      //	{
      if (c != '\n')
	{
	  if (arbre_originel==NULL) // Cas où c'est le premier mot
	    {
	      printf("arbre =NULL \n");
	      init_dico(&arbre_originel,c);
	      
	      arbre=arbre_originel->arbre;
	      }
	  
	  else // Cas où le dico n'est pas vide
	    {
	      printf(" c: %c\n", c);
	      rec=rech(arbre,c);
	      printf("adr rech %p\n",rech(arbre,c));
	      
	      if (rec==NULL)
		{
		  printf("rech  = NUll \n");
		  ajout_dico(&(arbre),&(rec),c);
		  arbre=rec->arbre;
		}
	
	  
	      else
		{// Cas où le début du mot existe déjà et qu'on le complète
		  printf("rech pas null\n");
		  arbre=rec->arbre; // On va à l'étage d'après pour former le mot dans l'arbre
		  // affiche_dico(arbre);
		}
	    
	      // printf("lettre %c \n",arbre->lettre); 
	    }
	}
      else {
	printf("remise à 0\n");
	arbre=arbre_originel;
      }
      //arbre=arbre_originel; // On revient en haut de l'arbre pour commencer un nouveau mot
    }
  
  
  fclose(fp);


  return 0;
}
